package provide DS9 1.0

proc InitXPA {} {
    global xpa
    global ds9

    set xpa [xpacmdnew "DS9" $ds9(title)]

    xpacmdadd $xpa about \
	"-- get credits" \
	XPASendAbout "" "" \
	"" "" ""
    xpacmdadd $xpa analysis \
	"\[task number\]" \
	XPASendAnalysis "" "" \
	XPARcvdAnalysis "" ""

    xpacmdadd $xpa array \
	"\[xdim=<x>,ydim=<y>,bitpix=<b>,skip=<s>\]" \
	XPASendArray "" "" \
	XPARcvdArray "" "fillbuf=false"

    xpacmdadd $xpa blink \
	"\[yes|no\]" \
	XPASendBlink "" "" \
	XPARcvdBlink "" ""

    xpacmdadd $xpa block \
	"\[buffersize <value>\]\n       \[factor <value>\]\n       \[function average|sum\]\n       \[to fit\]" \
	XPASendBlock "" "" \
	XPARcvdBlock "" ""

    xpacmdadd $xpa blocking \
	"for SAOtng backward compatibility" \
	XPASendBlock "" "" \
	XPARcvdBlock "" ""

    xpacmdadd $xpa colormap \
	"\[<colormap>\]\n          \[invert yes|no\]" \
	XPASendColormap "" "" \
	XPARcvdColormap "" ""

    xpacmdadd $xpa contour \
	"\[yes|no\] | \[copy|paste <coordinate system>\]" \
	XPASendContour "" "" \
	XPARcvdContour "" ""

    xpacmdadd $xpa crosshair \
	"\[x y <coordinate system>\]" \
	XPASendCrosshair "" "" \
	XPARcvdCrosshair "" ""

    xpacmdadd $xpa cursor \
	"\[x y\] -- move pointer or crosshair" \
	"" "" "" \
	XPARcvdCursor "" ""

    xpacmdadd $xpa exit \
	"-- exit application" \
	"" "" "" \
	XPARcvdExit "" ""

    xpacmdadd $xpa file \
	"\[<filename>\]\n      \[mosaicimage <filename>\]\n      \[mosaicimages <filename>\]\n      \[mosaic <filename>\]" \
	XPASendFile "" "" \
	XPARcvdFile "" ""

    xpacmdadd $xpa fits \
	"\[<options>\]" \
	XPASendFits "" "" \
	XPARcvdFits "" "fillbuf=false"

    xpacmdadd $xpa frame \
	"\[center|clear|delete|new|reset|refresh|frameno \#|\#\]" \
	XPASendFrame "" "" \
	XPARcvdFrame "" ""

    xpacmdadd $xpa grid \
	"\[yes|no]" \
	XPASendGrid "" "" \
	XPARcvdGrid "" ""

    xpacmdadd $xpa iconify \
	"\[yes|no]" \
	XPASendIconify "" "" \
	XPARcvdIconify "" ""

    xpacmdadd $xpa mode \
	"\[pointer|crosshair|colorbar|pan|zoom|rotate|examine\] -- cursor commands" \
	XPASendMode "" "" \
	XPARcvdMode "" ""

    xpacmdadd $xpa mosaicimage \
	"\[<options>\]" \
	XPASendMosaicImage "" "" \
	XPARcvdMosaicImage "" "fillbuf=false"

    xpacmdadd $xpa orient \
	"\[none|X|Y|XY\] -- orient current frame" \
	XPASendOrient "" "" \
	XPARcvdOrient "" ""

    xpacmdadd $xpa {page setup} \
	"\[orientation portrait|landscape\]\n            \[pagescale scaled|fixed\]\n            \[pagesize letter|legal|a4\] -- print page setup" \
	XPASendPageSetup "" "" \
	XPARcvdPageSetup "" ""

    xpacmdadd $xpa pan \
	"\[x y <corrdinate system>\]\n     \[to x y <corrdinate system>\]" \
	XPASendPan "" "" \
	XPARcvdPan "" ""

    xpacmdadd $xpa print \
	"\[destination printer|file\]\n       \[command <command>\]\n       \[filename <filename>\]\n       \[palette rgb|cmyk|gray\]\n       \[level 1|2\]\n       \[interpolate yes|no\]\n       \[resolution 53|72|75|150|300|600\]" \
	XPASendPrint "" "" \
	XPARcvdPrint "" ""

    xpacmdadd $xpa quit \
	"-- exit application" \
	"" "" "" \
	XPARcvdExit "" ""

    xpacmdadd $xpa regions \
	"\[movefront\]\n        \[moveback\]\n        \[selectall\]\n        \[selectnone\]\n        \[deleteall\]\n        \[file <regions file>\]\n        \[format ds9|saotng|saoimage|pros\]\n        \[coord <coordinate system>\]\n        \[coordformat degree|sexagesimal\]\n        <region commands>" \
	XPASendRegions "" "" \
	XPARcvdRegions "" "fillbuf=false"

    xpacmdadd $xpa rotate \
	"\[<value>\]\n        \[to <value>\]" \
	XPASendRotate "" "" \
	XPARcvdRotate "" ""

    xpacmdadd $xpa scale \
	"\[linear|log|squared|sqrt\]\n       \[limits <minvalue> <maxvalue>\]\n       \[mode\]\[minmax|zscale|user\]\n       \[scope\]\[local|global\] -- color scale distribution" \
	XPASendScale "" "" \
	XPARcvdScale "" ""

    xpacmdadd $xpa source \
	"\[filename\] -- source tcl source code" \
	"" "" "" \
	XPARcvdSource "" ""

    xpacmdadd $xpa tcl \
	"\[<tcl command>\] -- execute tcl command" \
	"" "" "" \
	XPARcvdTcl "" ""

    xpacmdadd $xpa tile \
	"\[yes|no\]\n      \[mode grid|row|column\]" \
	XPASendTile "" "" \
	XPARcvdTile "" ""

    xpacmdadd $xpa view \
	"\[info yes|no\]\n      \[panner yes|no\]\n      \[magnifier yes|no\]\n      \[buttons yes|no\]\n      \[colorbar yes|no\]\n      \[horzgraph yes|no\]\n      \[vertgraph yes|no\]\n      \[wcs yes|no\]\n      \[detector yes|no\]\n      \[amplifier yes|no\]\n      \[physical yes|no\]\n      \[image yes|no\] -- enable/disable gui display" \
	XPASendView "" "" \
	XPARcvdView "" ""

    xpacmdadd $xpa version \
	"-- display version" \
	XPASendVersion "" "" \
	"" "" ""
    xpacmdadd $xpa wcs \
	"\[fk4|fk5|galactic|ecliptic\]\n     \[align yes|no\]\n     \[format degrees|sexagesimal\]" \
	XPASendWCS "" "" \
	XPARcvdWCS "" ""

    xpacmdadd $xpa zoom \
	"\[<value>\]\n      \[to fit\]\n      \[to <value>\]" \
	XPASendZoom "" "" \
	XPARcvdZoom "" ""
}

proc XPASendAbout {xpa cdata param} {
    xpasetbuf $xpa [AboutMessage]
}

proc XPASendAnalysis {xpa cdata param} {
    global analysisMenu
    global analysisType
    global analysisCmd

    set result ""
    foreach a [array names analysisMenu] {
	set result "$result\#$a"
	set result "$result\n$analysisMenu($a)"
	set result "$result\n$analysisType($a)"
	set result "$result\n$analysisCmd($a)"
	set result "$result\n\n"
    }
    xpasetbuf $xpa $result
}

proc XPARcvdAnalysis {xpa cdata param buf len} {
    AnalysisCmd $param
}

proc XPASendArray {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdArray {xpa cdata param buf len} {
    global current

    if {$current(frame) != ""} {
	StartLoad
	set ch [xparec $xpa datachan]
	fconfigure $ch -translation binary
	if {[catch {$current(frame) load array channel $ch $param}]} {
	    xpaerror $xpa "Unable to load Array File"
	}
	FinishLoad
    }
}

proc XPASendBlink {xpa cdata param} {
    global ds9
    if {$ds9(displaymode) == blink} {
	xpasetbuf $xpa 1
    } else {
	xpasetbuf $xpa 0
    }
}

proc XPARcvdBlink {xpa cdata param buf len} {
    global ds9
    if {[FromYesNo $param]} {
	set ds9(displaymode) blink
    } else {
	set ds9(displaymode) single
    }
    DisplayMode
}

proc XPASendBlock {xpa cdata param} {
    global block
    switch -- [string tolower $param] {
	buffersize {xpasetbuf $xpa "$block(buffersize)\n"}
	function {xpasetbuf $xpa "$block(function)\n"}
	factor -
	default {xpasetbuf $xpa "$block(factor)\n"} 
    }
}

proc XPARcvdBlock {xpa cdata param buf len} {
    global block

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    buffersize {
		incr i
		set block(buffersize) [lindex $param $i]
		ChangeBlockBufferSize
	    }
	    factor {
		incr i
		set block(factor) [lindex $param $i]
		ChangeBlockFactor
	    }
	    function {
		incr i
		set block(function) [string tolower [lindex $param $i]]
		ChangeBlockFunction
	    }
	    to {BlockToFit}
	    default {
		set block(factor) $item
		ChangeBlockFactor
	    }
	}
	incr i
    }
}

proc XPASendContour {xpa cdata param} {
    global contour
    xpasetbuf $xpa [ToYesNo $contour(view)]
}

proc XPARcvdContour {xpa cdata param buf len} {
    global contour
    global current
    switch -- [string tolower [lindex $param 0]] {
	copy {ContourCopy}
	paste {ContourPaste [lindex $param 1]}
	default {
	    set contour(view) [FromYesNo $param]
	    ContourUpdate
	}
    }
}

proc XPASendColormap {xpa cdata param} {
    global colorbar
    switch -- [string tolower $param] {
	invert {xpasetbuf $xpa [ToYesNo $colorbar(invert)]}
	default {xpasetbuf $xpa "$colorbar(map)\n"}
    }
}

proc XPARcvdColormap {xpa cdata param buf len} {
    global colorbar
    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    invert {
		incr i
		set colorbar(invert) [FromYesNo [lindex $param $i]]
		InvertColorbar
	    }
	    default {
		set colorbar(map) $item
		ChangeColormap
	    }
	}
	incr i
    }
}

proc XPASendCrosshair {xpa cdata param} {
    global current
    set sys $param
    if {$current(frame) != ""} {
	if {$sys == ""} {
	    set sys image
	}
	xpasetbuf $xpa "[$current(frame) get crosshair $sys]\n"
    }
}

proc XPARcvdCrosshair {xpa cdata param buf len} {
    global current
    global ds9
    if {$current(frame) != ""} {
	set x [lindex $param 0]
	set y [lindex $param 1]
	set sys [lindex $param 2]
	if {$sys == ""} {
	    set sys image
	}
	set ds9(mode) crosshair
	ChangeMode
	$current(frame) crosshair $x $y $sys
	set coord [$current(frame) get crosshair]
	UpdateInfoBox $current(frame) \
	    [lindex $coord 0] [lindex $coord 1] canvas
    }
}

proc XPARcvdCursor {xpa cdata param buf len} {
    global current
    if {$current(frame) != ""} {
	set x [lindex $param 0]
	set y [lindex $param 1]
	ArrowKeyFrame $current(frame) $x $y
    }
}

proc XPARcvdExit {xpa cdata param buf len} {
    QuitDS9
}

proc XPASendFile {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdFile {xpa cdata param buf len} {
    global ds9

    set ds9(xpa) $xpa
    switch -- [lindex $param 0] {
	mosaicimage {LoadMosaicExtFile [lindex $param 1]}
	mosaicimages {LoadMosaicFiles [lindex $param 1]}
	mosaic {LoadFits [lindex $param 1] mosaic}
	default {LoadFits $param ""}
    }
    set ds9(xpa) 0
}

proc XPASendFits {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdFits {xpa cdata param buf len} {
    global current
    if {$current(frame) != ""} {
	StartLoad
	set ch [xparec $xpa datachan]
	fconfigure $ch -translation binary
	if {[catch {$current(frame) load fits channel $ch $param}]} {
	    xpaerror $xpa "Unable to load Fits File"
	}
	FinishLoad
    }
}

proc XPASendFrame {xpa cdata param} {
    global current
    switch -- [string tolower $param] {
	frameno -
	default {
	    if {[string range $current(frame) 0 4]=="Frame"} {
		xpasetbuf $xpa "[string range $current(frame) 5 end]\n"
	    } else {
		xpasetbuf $xpa "[string range $current(frame) 7 end]\n"
	    }
	}
    }
}

proc XPARcvdFrame {xpa cdata param buf len} {
    global current
    global ds9
    global active

    set cmd [string tolower [lindex $param 0]]
    switch -- $cmd {
	center {CenterFrame}
	clear {ClearFrame}
	delete {DeleteCurrentFrame}
	new {CreateFrame}
	reset {ResetFrame}
	refresh {UpdateFrame}
	hide {
	    set active($current(frame)) 0
	    UpdateActiveFrames
	}
	show {
	    set active([lindex $param 1]) 1
	    UpdateActiveFrames
	}
	frameno {CreateGotoFrame [lindex $param 1]}
	default {CreateGotoFrame [lindex $param 0]}
    }
}

proc XPASendGrid {xpa cdata param} {
    global grid
    xpasetbuf $xpa [ToYesNo $grid(view)]
}

proc XPARcvdGrid {xpa cdata param buf len} {
    global grid
    set grid(view) [FromYesNo $param]
    GridUpdate
}

proc XPASendIconify {xpa cdata param} {
    global ds9
    if {[wm state $ds9(top)] == "normal"} {
	xpasetbuf $xpa "no\n"
    } else {
	xpasetbuf $xpa "yes\n"
    }
}

proc XPARcvdIconify {xpa cdata param buf len} {
    global ds9
    if {[FromYesNo $param]} {
	wm iconify $ds9(top)
    } else {
	wm deiconify $ds9(top)
    }
}

proc XPASendMode {xpa cdata param} {
    global ds9
    xpasetbuf $xpa "$ds9(mode)\n"
}

proc XPARcvdMode {xpa cdata param buf len} {
    global ds9
    set ds9(mode) [string tolower $param]
    ChangeMode
}

proc XPASendMosaicImage {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdMosaicImage {xpa cdata param buf len} {
    global current
    if {$current(frame) != ""} {
	StartLoad
	set ch [xparec $xpa datachan]
	fconfigure $ch -translation binary
	if {[catch {$current(frame) load fits mosaic ext channel $ch $param}]} {
	    xpaerror $xpa "Unable to load mosaic ext File"
	}
	FinishLoad
    }
}

proc XPASendOrient {xpa cdata param} {
    global current
    xpasetbuf $xpa "$current(orient)\n"
}

proc XPARcvdOrient {xpa cdata param buf len} {
    global current
    set current(orient) [string tolower $param]
    ChangeOrient
}

proc XPASendPageSetup {xpa cdata param} {
    global ps
    switch -- [string tolower $param] {
	orientation {xpasetbuf $xpa "$ps(orient)\n"}
	pagescale {xpasetbuf $xpa "$ps(scale)\n"}
	pagesize {xpasetbuf $xpa "$ps(size)\n"}
    }
}

proc XPARcvdPageSetup {xpa cdata param buf len} {
    global ps

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    orientation {incr i; set ps(orient) [lindex $param $i]}
	    pagescale {incr i; set ps(scale) [lindex $param $i]}
	    pagesize {incr i; set ps(size) [lindex $param $i] }
	}
	incr i
    }
}

proc XPASendPan {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	if {$param == ""} {
	    set param image
	}
	xpasetbuf $xpa "[$current(frame) get pan $param]\n"
    }
}

proc XPARcvdPan {xpa cdata param buf len} {
    if {[string tolower [lindex $param 0]] != "to"} {
	set x [lindex $param 0]
	set y [lindex $param 1]
	set sys [lindex $param 2]
	Pan $x $y $sys
    } else {
	set x [lindex $param 1]
	set y [lindex $param 2]
	set sys [lindex $param 3]
	PanTo $x $y $sys
    }
}

proc XPASendPrint {xpa cdata param} {
    global ps
    switch -- [string tolower $param] {
	destination {xpasetbuf $xpa "$ps(dest)\n"}
	command {xpasetbuf $xpa "$ps(cmd)\n"}
	filename {xpasetbuf $xpa "$ps(fileName)\n"}
	palette {xpasetbuf $xpa "$ps(color)\n"}
	level {xpasetbuf $xpa "$ps(level)\n"}
	interpolate {xpasetbuf $xpa [ToYesNo $ps(interpolate)]}
	resolution {xpasetbuf $xpa "$ps(resolution)\n"}
    }
}

proc XPARcvdPrint {xpa cdata param buf len} {
    global ps

    set i 0
    set l [llength $param]
    if {$l > 0} {
	while {$i < $l} {
	    set item [lindex $param $i]
	    switch -- $item {
		destination {incr i; set ps(dest) [lindex $param $i]}
		command {incr i; set ps(cmd) [lindex $param $i]}
		filename {incr i; set ps(fileName) [lindex $param $i] }
		palette {incr i; set ps(color) [lindex $param $i] }
		level {incr i; set ps(level) [lindex $param $i] }
		interpolate {
		    incr i; set ps(interpolate) [FromYesNo [lindex $param $i]]
		}
		resolution {incr i; set ps(resolution) [lindex $param $i] }
	    }
	    incr i
	}
    } else {
	PostScript
    }
}

proc XPASendRegions {xpa cdata param} {
    global current
    global marker

    if {$current(frame) != ""} {
	set format $marker(saveformat)
	set coord $marker(savecoord)
	set coordformat $marker(savecoordformat) 

	set i 0
	set l [llength $param]
	while {$i < $l} {
	    set item [lindex $param $i]
	    switch -- $item {
		format {incr i; set format [lindex $param $i]}
		coord {incr i; set coord [lindex $param $i]}
		coordformat {incr i; set coordformat [lindex $param $i]}
	    }
	    incr i
	}

	xpasetbuf $xpa [$current(frame) marker list $format $coord $coordformat]
    }
}

proc XPARcvdRegions {xpa cdata param buf len} {
    global current
    global marker

    if {$current(frame) != ""} {
	if {$param != ""} {
	    switch -- [lindex $param 0] {
		movefront {$current(frame) marker move front}
		moveback {$current(frame) marker move back}

		selectall {$current(frame) marker select all}
		selectnone {$current(frame) marker unselect all}
		deleteall {$current(frame) marker delete all}

		file {catch {$current(frame) marker load [lindex $param 1]}}
		format {
		    set marker(saveformat) [lindex $param 1]
		    UpdateMarkerFormatMenu
		}
		coord {set marker(savecoord) [lindex $param 1]}
		coordformat {set marker(savecoordformat) [lindex $param 1]}

		default {
		    catch {$current(frame) marker command $param}
		}
	    }
	} else {
	    # read from tcl channel
	    set fd [xparec $xpa datafd]
	    $current(frame) marker load $fd
	}
    }
}

proc XPASendRotate {xpa cdata param} {
    global current
    xpasetbuf $xpa "$current(rotate)\n"
}

proc XPARcvdRotate {xpa cdata param buf len} {
    global current
    if {[string tolower [lindex $param 0]] != "to"} {
	Rotate $param
    } else {
	set current(rotate) [lindex $param 1]
	ChangeRotate
    }
}

proc XPASendScale {xpa cdata param} {
    global current
    global scale
    switch -- [string tolower $param] {
	limits {
	    if {$current(frame) != ""} {
		set lims [$current(frame) get clip default]
		xpasetbuf $xpa "[lindex $lims 0] [lindex $lims 1]\n"
	    }
	}
	mode {xpasetbuf $xpa "$scale(mode)\n"}
	scope {xpasetbuf $xpa "$scale(scope)\n"}
	default {xpasetbuf $xpa "$current(scale)\n"}
    }
}

proc XPARcvdScale {xpa cdata param buf len} {
    global current
    global scale
    global user

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    limits {
		incr i
		set user(low) [lindex $param $i]
		incr i
		set user(high) [lindex $param $i]
		ScaleLimit $user(low) $user(high)
	    }
	    mode {
		incr i
		set scale(mode) [string tolower [lindex $param $i]]
		ScaleMode
	    }
	    minmax -
	    zscale -
	    user {
		set scale(mode) [string tolower [lindex $param $i]]
		ScaleMode
	    }
	    scope {
		incr i
		set scale(scope) [string tolower [lindex $param $i]]
		ScaleScope
	    }
	    local -
	    global{
		set scale(scope) [string tolower [lindex $param $i]]
		ScaleScope
	    }
	    default {
		set current(scale) [string tolower $item]
		ChangeColorScale
	    }
	}
	incr i
    }
}

proc XPARcvdSource {xpa cdata param buf len} {
    uplevel #0 source $param
}

proc XPARcvdTcl {xpa cdata param buf len} {
    if [string compare $param {}] {
        eval $param
    } else {
        eval $buf
    }
}

proc XPASendTile {xpa cdata param} {
    global ds9
    global tile
    switch -- $param {
	mode {xpasetbuf $xpa "$tile(mode)\n"}
	default {
	    if {$ds9(displaymode)=="tile"} {
		xpasetbuf $xpa [ToYesNo 1]
	    } else {
		xpasetbuf $xpa [ToYesNo 0]
	    }
	}
    }
}

proc XPARcvdTile {xpa cdata param buf len} {
    global ds9
    global tile
    switch -- [lindex $param 0] {
	mode {set tile(mode) [lindex $param 1]}
	default {
	    if {[FromYesNo [lindex $param 0]]} {
		set ds9(displaymode) tile
	    } else {
		set ds9(displaymode) single
	    }
	}
    }
    DisplayMode
}

proc XPASendWCS {xpa cdata param} {
    global wcs
    switch -- [string tolower $param] {
	align {xpasetbuf $xpa [ToYesNo $wcs(align)]}
	format {xpasetbuf $xpa "$wcs(format)\n"}
	default {xpasetbuf $xpa "$wcs(system)\n"}
    }
}

proc XPARcvdWCS {xpa cdata param buf len} {
    global wcs

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    align {
		incr i
		set wcs(align) [FromYesNo [lindex $param $i]]
		AlignWCSFrame
	    }
	    format {incr i; set wcs(format) [string tolower [lindex $param $i]]}
	    default {set wcs(system) [string tolower $item]}
	}
	incr i
    }
}

proc XPASendView {xpa cdata param} {
    global info
    global pan
    global mag
    global buttons
    global colorbar
    global graphHorz
    global graphVert

    switch -- [string tolower $param] {
	info {xpasetbuf $xpa [ToYesNo $info(view)]}
	panner {xpasetbuf $xpa [ToYesNo $pan(view)]}
	magnifier {xpasetbuf $xpa [ToYesNo $mag(view)]}
	buttons {xpasetbuf $xpa [ToYesNo $buttons(view)]}
	colorbar {xpasetbuf $xpa [ToYesNo $colorbar(view)]}
	horzgraph {xpasetbuf $xpa [ToYesNo $graphHorz(view)]}
	vertgraph {xpasetbuf $xpa [ToYesNo $graphVert(view)]}

	wcs {xpasetbuf $xpa [ToYesNo $info(wcs)]}
	detector {xpasetbuf $xpa [ToYesNo $info(detector)]}
	amplifier {xpasetbuf $xpa [ToYesNo $info(amplifier)]}
	physical {xpasetbuf $xpa [ToYesNo $info(physical)]}
	image {xpasetbuf $xpa [ToYesNo $info(image)]}
	default {}
    }
}

proc XPARcvdView {xpa cdata param buf len} {
    global info
    global pan
    global mag
    global buttons
    global colorbar
    global graphHorz
    global graphVert

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    info {incr i; set info(view) [FromYesNo [lindex $param $i]]}
	    panner {incr i; set pan(view) [FromYesNo [lindex $param $i]]}
	    magnifier {incr i; set mag(view) [FromYesNo [lindex $param $i]]}
	    buttons {incr i; set buttons(view) [FromYesNo [lindex $param $i]]}
	    colorbar {incr i; set colorbar(view) [FromYesNo [lindex $param $i]]}
	    horzgraph {incr i; set graphHorz(view) [FromYesNo [lindex $param $i]]}
	    vertgraph {incr i; set graphVert(view) [FromYesNo [lindex $param $i]]}

	    wcs {incr i; set info(wcs) [FromYesNo [lindex $param $i]]}
	    detector {incr i; set info(detector) [FromYesNo [lindex $param $i]]}
	    amplifier {incr i; set info(amplifier) [FromYesNo [lindex $param $i]]}
	    physical {incr i; set info(physical) [FromYesNo [lindex $param $i]]}
	    image {incr i; set info(image) [FromYesNo [lindex $param $i]]}
	}
	incr i
    }
    UpdateView
    UpdateInfoPanel
}

proc XPASendVersion {xpa cdata param} {
    global ds9
    xpasetbuf $xpa "$ds9(title) $ds9(version)\n"
}

proc XPASendZoom {xpa cdata param} {
    global current
    xpasetbuf $xpa "$current(zoom)\n"
}

proc XPARcvdZoom {xpa cdata param buf len} {
    global current
    
    switch -- [lindex $param 0] {
	to {
	    switch -- [lindex $param 1] {
		fit {ZoomToFit}
		default {
		    set current(zoom) [lindex $param 1]
		    ChangeZoom
		}
	    }
	}
	default {Zoom $param}
    }
}

proc ToYesNo {value} {
    if {$value == 1} {
	return "yes\n"
    } else {
	return "no\n"
    }
}

proc FromYesNo {value} {
    set v [string tolower $value]

    if {$v == "no" || $v == "false" || $v == "off" || $v == 0} {
	return 0
    } else {
	return 1
    }
}
